/* ikePolicy.js - API library for IKE Policy configuration */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01a,7OCT10,mvb  written. 
*/

var prevDirection = 0;
var prevMode = 0;

function IkePolInitialSettings ()
	{
    prevDirection = comboSelectedValueGet ('selDirection');
    prevMode = comboSelectedValueGet ('selExchangeType');
	
	authenticationMethodCheck ();
	localIdentTypeCheck ();
	remoteIdentTypeCheck ();
    modeCfgStatusCheckWrap ();
    comboValueSet ('selExchangeType', prevMode);
	DPDCheck ();
    return;
  	}
function modeCfgStatusCheck (modeCfgValue)
 {
  if (modeCfgValue == null) return;
  var hrefObj = document.getElementById('hrefViewModeCfgRec');
  switch (modeCfgValue) 
  	{
  	case 0: /* NO */
  		fieldStateChangeWr ('selModeConfigRecord btnViewSelected selxAuthConfigAuthType','','selDirection selExchangeType','');
  		comboValueSet ('selDirection', prevDirection);
  		comboValueSet ('selExchangeType', prevMode);
		if (hrefObj)
			hrefObj.onclick = function () {return false;};
  		break;
  	case 1: /* YES */
  	    prevDirection = comboSelectedValueGet ('selDirection');
  	    prevMode = comboSelectedValueGet ('selExchangeType');
  		comboValueSet ('selDirection', 1);
  		fieldStateChangeWr ('selDirection','','selModeConfigRecord btnViewSelected selxAuthConfigAuthType selExchangeType','');
  		comboValueSet ('selExchangeType', 1);
		if (hrefObj)
			hrefObj.onclick = function () {return true;};
		viewChange();
  		break;
  	}
    xauthStatusCheckWrap ();
  }

function xauthStatusCheck (xauthStatus)
	{
	if (xauthStatus == null) return;
	switch (xauthStatus)
		{
		case 0: /* None */
			fieldStateChangeWr ('txtxAuthConfigUserName txtxAuthConfigPasswd selxAuthConfigAuthType','','','');
			break;
		case 1: /* IPSEC Host */
			fieldStateChangeWr ('selxAuthConfigAuthType','','txtxAuthConfigUserName txtxAuthConfigPasswd','');
			break; 
		case 2: /* Edge Device */
			fieldStateChangeWr ('txtxAuthConfigUserName txtxAuthConfigPasswd','','selxAuthConfigAuthType','');
			break; 
		}
	}

function localIdentTypeCheck ()
	{
	var selValue = comboSelectedValueGet ('selLocalIdentifier');
	if (selValue == null) return;
	switch (parseInt (selValue, 10))
		{
		case 0:	/* LOCAL ID */
            fieldStateChangeWr ('txtAddIkeLocId', '', '', '');
            break;
		default:
			fieldStateChangeWr ('', '', 'txtAddIkeLocId', '');
			break;
		}
	return;
	}

function remoteIdentTypeCheck ()
	{
	var selValue = comboSelectedValueGet ('selRemoteIdentifier');
	if (selValue == null) return;
	switch (parseInt (selValue, 10))
		{
		case 0:	/* REMOTE ID */
			fieldStateChangeWr ('txtAddIkePeerID', '', 'rdbpresharedKeyEnable txtPresharedKey', '');
			//authenticationMethodCheck ();
            break;
		case 3:	/* DER ASN1 DN */
			fieldStateChangeWr ('rdbpresharedKeyEnable txtPresharedKey', '', 'txtAddIkePeerID', '');
			document.getElementById('rdbpresharedKeyDisable').checked = true;
            break;
		default:
			fieldStateChangeWr ('', '', 'txtAddIkePeerID rdbpresharedKeyEnable txtPresharedKey', '');
			//authenticationMethodCheck ();
			break;
		}
	return;
	}

function authenticationMethodCheck ()
    {
    if (document.getElementById('rdbpresharedKeyDisable').checked)
        {
        fieldStateChangeWr ('txtPresharedKey','','','');
        optionValueSelect ('selLocalIdentifier', 'hdDER-ASN1DNOpt');
        localIdentTypeCheck ();
        optionValueSelect ('selRemoteIdentifier', 'hdDER-ASN1DNOpt');
        remoteIdentTypeCheck ();
        }
    else
       fieldStateChangeWr ('','','txtPresharedKey','');
    }

function alrtMsgForDERASN1 ()
    {
    var localSelVal = comboSelectedValueGet ('selLocalIdentifier');
    var remoteSelVal = comboSelectedValueGet ('selRemoteIdentifier');
    var rdbRSASignatureObj = document.getElementById('rdbpresharedKeyDisable');
    if(rdbRSASignatureObj.checked)
        {
        if(parseInt(localSelVal, 10) != 3 || parseInt(remoteSelVal, 10) != 3)
            {
            alert("RSA-Signature selected. Please select 'DER ASN1 DN' for both Local and Remote Identifier Type");
            return false;
            }
        }
    return true;
    }

function modeCfgStatusCheckWrap ()
 {
  var selValue = radioCheckedValueGet ('IpsecIKEPolicy.ModeConfigStatus');
  if (!selValue) return;
  modeCfgStatusCheck (parseInt (selValue, 10));
  }
function xauthStatusCheckWrap ()
	{
	var selValue = radioCheckedValueGet ('IpsecIKEPolicy.XAUTHType');
    if (!selValue) return;
    xauthStatusCheck (parseInt (selValue, 10));
    }


function ikePolValidate ()
    {
    /* L10N Error Message Collection Start */
     var errMsgL10n1 ='Please enter a name for the IKE policy.';
     var errMsgL10n2 ='Please enter a valid local identifier.';
     var errMsgL10n3 ='Please enter a valid peer identifier.';
     var errMsgL10n4 ='Please enter the pre-shared key for this connection.';
     var errMsgL10n5 ='Please enter a valid XAUTH user name.';
     var errMsgL10n6 ='Please enter a valid XAUTH password.';
     var errMsgL10n7 ='Invalid pre-shared key: Please enter key with length between 8 - 49 characters.';
     var errMsgL10n8 ='SA lifetime value should not exceed 10 digits.';
     var errMsgL10n9 ='Please enter the life-time in seconds for the security association created by this policy.';
     var errMsgL10n10 ='Invalid Detection Period - Please enter a value between 10-999.';
     var errMsgL10n11 ='Invalid Detection Period -';
     var errMsgL10n12 ='Invalid Reconnect after failure count - Please enter a value between 3-99.';
     var errMsgL10n13 ='Invalid Reconnect after failure count -';
     var errMsgL10n14 ='No Mode Config Records to Configure IKE Policy. Please Configure a Mode Config Record';
     
      /* L10N Error Message Collection End */
      
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtAddIkePolName," +errMsgL10n1;
    txtFieldIdArr[1] = "txtAddIkeLocId," +errMsgL10n2;                       
    txtFieldIdArr[2] = "txtAddIkePeerID," + errMsgL10n3;
    txtFieldIdArr[3] = "txtPresharedKey," + errMsgL10n4;
    txtFieldIdArr[4] = "txtxAuthConfigUserName," + errMsgL10n5;
    txtFieldIdArr[5] = "txtxAuthConfigPasswd," + errMsgL10n6;
    txtFieldIdArr[6] = "selModeConfigRecord," + errMsgL10n14;
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
         
    var txtFieldIkeArray = new Array();
    txtFieldIkeArray[0] = "txtAddIkeLocId,";
    txtFieldIkeArray[1] = "txtAddIkePeerID,";
    
    if(isProblemCharArrayCheck2(txtFieldIkeArray) == false)
       return false;
         
    var txtFieldArray = new Array();
    txtFieldArray[0] = "txtAddIkePolName,";
    txtFieldArray[1] = "txtPresharedKey,";
    txtFieldArray[2] = "txtxAuthConfigUserName,";
    txtFieldArray[3] = "txtxAuthConfigPasswd,";
       
	if (isProblemCharArrayCheck (txtFieldArray) == false)
         return false;
         
    var txtFieldArrayP = new Array ();
    txtFieldArrayP[0] = "txtPresharedKey,";
    
    if(isProblemCharSpArrayCheck(txtFieldArrayP,"\\") == false)
            return false;            


    var xAuthTypeSelVal = radioCheckedValueGet ('IpsecIKEPolicy.XAUTHType');
    var txtFieldIDArray = new Array();
    txtFieldIDArray[0] = "txtxAuthConfigUserName,";
    txtFieldIDArray[1] = "txtxAuthConfigPasswd,";
    if(xAuthTypeSelVal == 1)
        {        
        if(isProblemCharSpArrayCheck(txtFieldIDArray,'*:.') == false)
            return false;
       }
    var result = false;
    result = fieldLengthCheck ('txtPresharedKey', 8, 49,errMsgL10n7);   
    if (result == false)
        return false;
    var saIkeLifeTimeObj = document.getElementById('txtAddIkePolLifeTime');
    if (!saIkeLifeTimeObj || saIkeLifeTimeObj.disabled) return true;
    if (saIkeLifeTimeObj.value.length > 10)
    	{
        alert (errMsgL10n8);
    	return false;    	
    	}
    if (numericValueRangeCheck (saIkeLifeTimeObj, 1, errMsgL10n9, 0, 2147483647, true, "", "") == false)
         return false;

	obj = document.getElementById('txtDetectionPeriod');
	if (numericValueRangeCheck (obj, 1, errMsgL10n10, 10, 999, true, errMsgL10n11, "") == false)
	    return false; 

	obj = document.getElementById('txtReconnectCount');
	if (numericValueRangeCheck (obj, 1, errMsgL10n12, 3, 99, true, errMsgL10n13, "") == false)
	    return false; 
    var selLocalIdentifierVal = comboSelectedValueGet ('selLocalIdentifier');
    if(parseInt(selLocalIdentifierVal, 10) == 1)
        {
        if(!validateFQDN('txtAddIkeLocId'))
            return false;
        }
    
    var selRemoteIdentifierVal = comboSelectedValueGet ('selRemoteIdentifier');
    if(parseInt(selRemoteIdentifierVal, 10) == 1)
        {
        if(!validateFQDN('txtAddIkePeerID'))
            return false;
        }

    /* enable dependent stuff if modeconfig is enabled */
    var exchTypeObj = document.getElementById('selExchangeType');
    if (!exchTypeObj) return;

        {
        var objIdArr = new Array ();
        objIdArr[0] = 'selExchangeType';
        objIdArr[1] = 'selLocalIdentifier';
        objIdArr[2] = 'selRemoteIdentifier';
        objIdArr[3] = 'selDirection';
        for (var i = 0; i < objIdArr.length; ++i)
            {
            var obj = document.getElementById(objIdArr[i]);
            if (obj)
                 obj.disabled = false;
            }
        }
    
    if(alrtMsgForDERASN1 () == false)
        return false;

    return true;
    }
function IkePolInitialSettingsWrap ()
    {
    IkePolInitialSettings ();
    DPDCheck ();
    var selOptVal = document.getElementById('rdbModeConfigY').value
    var selOptVal2 = document.getElementById('rdbModeConfigN').value
    if(!selOptVal || selOptVal2 == 0) return;
    viewChange();
    }

function DPDCheck ()
	{
	/* L10N Error Message Collection Start */
	var errMsgL10n10 ='Invalid Detection Period - Please enter a value between 10-999';
    var errMsgL10n11 ='Invalid Detection Period -';
    var errMsgL10n12 ='Invalid Reconnect after failure count - Please enter a value between 3-99';
    var errMsgL10n13 ='Invalid Reconnect after failure count -';
    errMsgObjL10n = document.getElementById ('hd.invalDetectPeriodBet');
    if (errMsgObjL10n) errMsgL10n10 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalDetectPeriod1');
    if (errMsgObjL10n) errMsgL10n11 = errMsgObjL10n.value+"-";
    errMsgObjL10n = document.getElementById ('hd.invalReconnectAftrFailBet');
    if (errMsgObjL10n) errMsgL10n12 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalReconnectAftrFail1');
    if (errMsgObjL10n) errMsgL10n13 = errMsgObjL10n.value+"-";


	depFieldCheck ('rdbDPDEnable', true, '','','txtReconnectCount txtDetectionPeriod','');
	depFieldCheck ('rdbDPDEnable', false, 'txtReconnectCount txtDetectionPeriod','','','');
	depFieldCheck ('rdbDPDDisable', true, 'txtReconnectCount txtDetectionPeriod','','','');
	depFieldCheck ('rdbDPDDisable', false, '','','txtReconnectCount txtDetectionPeriod','');

	obj = document.getElementById('txtDetectionPeriod');
	if (numericValueRangeCheck (obj , 1, 
                            errMsgL10n10,
                            10, 999, true, errMsgL10n11, "") == false)
	return false; 

	obj = document.getElementById('txtReconnectCount');
	if (numericValueRangeCheck (obj , 1, 
                           errMsgL10n12,
                            3, 99, true, errMsgL10n13, "") == false)
	return false; 

	}

function viewChange()
	{
	var obj=document.getElementById("selModeConfigRecord");
	if(obj.options.length==0||obj.disabled)
		{
		fieldStateChangeWr("btnViewSelected","","","");
		var selValue = radioCheckedValueGet ('IpsecIKEPolicy.ModeConfigStatus');
		if (!selValue) return;
			if(parseInt(selValue, 10) == 1){
				document.getElementById("lblWarning").innerHTML = "Please add <a href='?page=mode_config.htm'>Mode Config</a> to get the list of Mode Config Records here </span>";
			}
		}
	else
		{
		fieldStateChangeWr("","","btnViewSelected","");
		document.getElementById("lblWarning").innerHTML = "";
		var value=obj.options[obj.selectedIndex].value;
		var urlPath = "?page=pop_view_mode_config.htm&selModeVal="+ value;
		document.getElementById("btnViewSelected").name = urlPath
		}
	};

function getUrl ()
	{
	   if (document.getElementById("btnViewSelected").name == ''){}
	   else
	   {
	   var objName = document.getElementById("btnViewSelected").name
	   statusPop(objName)
	   }
	}
	
function validateIdentifier (fieldId,identifieType)
    {
    var selIdentifierVal = comboSelectedValueGet (identifieType);
    
    if(parseInt(selIdentifierVal, 10) == 1)
        {
        if(!validateFQDN(fieldId))
            return false;
        }
    return true;    
    }
