function wizardInit () {
    var remoteMgmtStatusObj = document.getElementById ('hdRemoteMgmtStatus');
    if (remoteMgmtStatusObj && remoteMgmtStatusObj.value != "" && remoteMgmtStatusObj.value != "1") {
        var statusMsgObj = document.getElementById('infoMsg');
        if (statusMsgObj) {
            var warMsg = "Please enable Remote Management to activate SSL VPN Configurations."
            if (statusMsgObj.innerHTML != "")
                statusMsgObj.innerHTML += "<br>" + warMsg;
            else
                statusMsgObj.innerHTML = warMsg;
        }
    }
    authTypeCheck ();
    enablePortalPageSections ();
}

function screen1Validate () {
    var portalLayoutNameObj = document.getElementById ('txtPorName');
    if (portalLayoutNameObj && portalLayoutNameObj.value != "") {
        var txtFieldIdArr = new Array (); 
        txtFieldIdArr[0] = "txtPorName, Please enter a valid Portal Layout";
        if (isProblemCharArrayCheck (txtFieldIdArr) == false)
            return false;
        var txtFieldIdArray = new Array ();     
        txtFieldIdArray[0] = "txtPorTle, Please enter a valid Portal Site Title";
        txtFieldIdArray[1] = "txtBanTle, Please enter a valid Banner Title";
        if (isProblemCharArrayCheck2 (txtFieldIdArray) == false)
            return false;
        if (alphaNumericValueCheck ("txtPorName", "-", "Invalid portal name: ") == false)
            return false;
        if (maxLimitReached ('txtBanMsg', 255, 'Banner message should not exceed maxlimit, ') == false)
            return false;
    }
    var vpnTunnelObj = document.getElementById ('chkVpnTunnel');
    var portForwardingObj = document.getElementById ('chkPortForwarding');
    if (!vpnTunnelObj || !portForwardingObj) return;
    if (!vpnTunnelObj.checked && !portForwardingObj.checked) {
    	alert ("Please select atleast one among VPN Tunnel and Port Forwarding options");
    	return false;
    }
    return true;
}

function moveToNextScreen (scrId) {
    var newScrId = parseInt (scrId, 10) + 1;
    displayScreen (scrId, newScrId);
    setTabHeading (newScrId);
}

function moveToBackScreen (scrId) {
    var newScrId = parseInt (scrId, 10) - 1;
    displayScreen (scrId, newScrId);
    setTabHeading (newScrId);
}

function setTabHeading (scrId) {
    var tabHeadingObj = document.getElementById ('divTabHeading');
    if (!tabHeadingObj) return;
    tabHeadingObj.innerHTML = "SSL VPN Wizard Step " + scrId + " of 6";
}

function displayScreen (currentScrId, nextScrId) {
    var oldScrObj = document.getElementById ('screen' + currentScrId);
    var newScrObj = document.getElementById ('screen' + nextScrId);
    if (!(newScrObj && oldScrObj)) return;
    newScrObj.className = "show";
    oldScrObj.className = "hide";
}

function authTypeCheck () {
    var selectedValue = comboSelectedValueGet ('selAuthType');
    if (!selectedValue) return;
    if (selectedValue == 'local')
        fieldStateChangeWr ('txtAuthSvr1 txtAuthPwd txtWorkGrp txtBindName txtRealm', '', 'txtPwd txtCfmPwd', '');
    else if (selectedValue == 'radius_pap' || selectedValue == 'radius_chap' || selectedValue == 'radius_mschap' || selectedValue == 'radius_mschapv2' || selectedValue == 'wikid_pap' || selectedValue == 'wikid_chap' || selectedValue == 'mias_pap' || selectedValue == 'mias_chap')
        fieldStateChangeWr ('txtWorkGrp txtBindName txtRealm txtPwd txtCfmPwd', '','txtAuthSvr1 txtAuthPwd', '');
    else if (selectedValue == 'ntdomain')
        fieldStateChangeWr ('txtAuthPwd txtBindName txtRealm txtPwd txtCfmPwd', '', 'txtAuthSvr1 txtWorkGrp', '');
    else if (selectedValue == 'active-directory')
        fieldStateChangeWr ('txtAuthPwd txtWorkGrp txtBindName txtPwd txtCfmPwd', '', 'txtAuthSvr1 txtRealm', '');
    else
        fieldStateChangeWr ('txtAuthPwd txtWorkGrp txtRealm txtPwd txtCfmPwd', '', 'txtAuthSvr1 txtBindName', '');
}
    
function screen2Validate () {
    var domainNameObj = document.getElementById ('txtDomName');
    if (domainNameObj && domainNameObj.value != "") {
        var txtFieldIdArr = new Array ();    
        txtFieldIdArr[0] = "txtDomName, Please enter a valid Domain name";
        txtFieldIdArr[1] = "txtAuthSvr1, Please enter a valid Authentication Server";    
        txtFieldIdArr[2] = "txtAuthPwd, Please enter a valid Authentication Secret";    
        txtFieldIdArr[3] = "txtWorkGrp, Please enter a valid Workgroup";
        txtFieldIdArr[4] = "txtBindName, Please enter a valid LDAP Base DN";
        txtFieldIdArr[5] = "txtRealm, Please enter a valid Active Directory Domain";    
        if (txtFieldArrayCheck (txtFieldIdArr) == false)
            return false;
        if (alphaNumericValueCheck ("txtDomName", "!@#$%^&()-_'{}.~", "Invalid domain name: ") == false)
            return false;
        if (alphaNumericValueCheck ("txtWorkGrp", "!@#$%^&()-_'{}.~", "Invalid workgroup: ") == false)
            return false;
        if (alphaNumericValueCheck ("txtRealm", "!@#$%^&()-_'{}.~", "Invalid active directory domain: ") == false)
            return false;
    }
    return true;
}

function screen3Validate () {
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtUserName, Please enter the UserName";
    txtFieldIdArr[1] = "txtPwd, Please enter Password";
    txtFieldIdArr[2] = "txtCfmPwd, Please Confirm Password";    
    txtFieldIdArr[3] = "txtTimeOut, Please enter the Value between 0-999";
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
        return false;  
    if (isProblemCharArrayCheck (txtFieldIdArr) == false)
        return false;
    var pwdObj = document.getElementById ('txtPwd');
    var cnfPwdObj = document.getElementById ('txtCfmPwd');
    if (pwdObj && !pwdObj.disabled && cnfPwdObj && !cnfPwdObj.disabled && pwdObj.value != cnfPwdObj.value) {
        alert ("Passwords do not match");
        document.getElementById ('txtPwd').focus();
        return false;
    }
    var txtTimeOutObj = document.getElementById ('txtTimeOut');
    if (txtTimeOutObj) {        
        if (numericValueRangeCheck (txtTimeOutObj, '', '', 0, 999, true, '', 'Minutes') == false) 
            return false;            
    }
    enablePortalPageSections ();
    return true;
}

function screen4Validate () {
    if (document.getElementById ('txtDnsSuffix').value != "") {
        if(validateFQDN('txtDnsSuffix') == false) 
           return false;     
    }
    if (ipv4AddrOctetsValidate ('tblPriDnsServer', 'IPD', false, true, 'Invalid Primary DNS IP address.', 'for octet', true) == false)
        return false;
    var secDnsObj = document.getElementById ('tblSecDnsServer');
    var secDnsObjArr = secDnsObj.getElementsByTagName ("INPUT");
    if ((secDnsObjArr[0].value != "") || (secDnsObjArr[1].value != "") || (secDnsObjArr[2].value != "") || (secDnsObjArr[3].value != "")) {
        if (ipv4AddrOctetsValidate ('tblSecDnsServer', 'IPD', false, true, 'Invalid Secondary DNS IP address.', 'for octet', true) == false)
            return false;
    }
    if (ipv4AddrOctetsValidate ('tblSnmpStrIpAddr', 'IPD', false, true, 'Invalid Client Address Range Begin.', 'for octet', true) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblSnmpEndIpAddr', 'IPD', false, true, 'Invalid Client Address Range End.', 'for octet', true) == false)
        return false;
    var clientStartIPInt = getIPInt('tblSnmpStrIpAddr');
    var clientEndIPInt = getIPInt('tblSnmpEndIpAddr');
    var clientAddrObj = document.getElementById ('tblSnmpStrIpAddr');
    var clientAddrObjArr = clientAddrObj.getElementsByTagName ("INPUT");
    if (!clientAddrObjArr[0].disabled) {
        if (compareIP (clientStartIPInt, clientEndIPInt) > 0) {
            alert ("Client Address Range End should be higher than or equal to Client Address Range Begin");
            return false;
        }
    }
    var destNetworkObj = document.getElementById ('tblSnmpIpAddr');
    var objArr = destNetworkObj.getElementsByTagName ("INPUT");
    if (objArr[0] && !objArr[0].disabled) {
        if (ipv4AddrOctetsValidate ('tblSnmpIpAddr', 'SN', false, true, 'Invalid IP address', 'for octet', true) == false)
            return false;
        
        if (parseInt (objArr[3].value, 10) == 0) {
            if (ipv4AddrOctetsValidate ('tblWi1IpSnetmask', 'SM', false, true, 'Invalid subnet mask', 'for octet', true) == false)
               return false;
        }
        else {
            if (ipv4AddrOctetsValidate ('tblWi1IpSnetmask', 'SNM', false, true, 'Invalid subnet mask', 'for octet', true) == false)
                return false;
        }
        if (subnetValidate ('tblSnmpIpAddr', 'tblWi1IpSnetmask',' for Destination Network')==false)
            return false;
    }
    return true;
}

function screen5Validate () {
    var appServerIpObj = document.getElementById ('tblIPAddr');
    var appServerIpObjArr = appServerIpObj.getElementsByTagName ("INPUT");
    var portObj = document.getElementById ('txtPort');
    if ((appServerIpObjArr[0].value != "") || (appServerIpObjArr[1].value != "") || (appServerIpObjArr[2].value != "") || (appServerIpObjArr[3].value != "") || (portObj.value != "")) {
        if (ipv4AddrOctetsValidate ('tblIPAddr', 'IPD', false, true, 'Invalid Local Server IP Address.', 'for octet', true) == false)
            return false;
        if (numericValueRangeCheck (portObj, 1, 'Invalid End Port - Please enter a value between 1 - 65535.', 1, 65535, true, 'Invalid End Port number', "") == false)
            return false;
    }
    var hostServerIpObj = document.getElementById ('tblSvrIPAddr');
    var hostServerIpObjArr = hostServerIpObj.getElementsByTagName ("INPUT");
    var fqdnObj = document.getElementById ('txtFQDN');
    if ((hostServerIpObjArr[0].value != "") || (hostServerIpObjArr[1].value != "") || (hostServerIpObjArr[2].value != "") || (hostServerIpObjArr[3].value != "") || (fqdnObj.value != "")) {
        var txtFieldIdArr = new Array ();    
        txtFieldIdArr[0] = "txtFQDN, Please enter a valid Fully Qualified Domain Name.";
        if (txtFieldArrayCheck (txtFieldIdArr) == false)
            return false;
        if (ipv4AddrOctetsValidate ('tblSvrIPAddr', 'IPD', false, true, 'Invalid Local Server IP Address.', 'for octet', true) == false)
            return false;
        if (!validateFQDN("txtFQDN"))
            return false;
    
        if (fqdnObj && fqdnObj.value.length > 110) { 
            alert ('FQDN maximum length must not exceed 110 characters.') 
            return false; 
        }
    }
    return true;
}

function setFieldVal (fldId, divId, hidFldId) {
    var fldObj = document.getElementById (fldId);
    var divObj = document.getElementById (divId);
    if (!(fldObj && divObj)) return;
    if (fldObj.value != "") {
        divObj.innerHTML = fldObj.value;
    }
    if (hidFldId) {
        var hdFldObj = document.getElementById (hidFldId);
        if (!hdFldObj) return;
        if (fldObj.value == "") {
            divObj.innerHTML = hdFldObj.value;
        }
    }
}

function setChkboxVal (chkObj, displayChkId) {
    var displayChkObj = document.getElementById (displayChkId);
    if (!displayChkObj) return;
    if (chkObj.checked) {
        displayChkObj.checked = true;
    }
    else {
        displayChkObj.checked = false;
    }
}

function setIpAddressVal (divIpId, displayTdId) {
    var divObj = document.getElementById (divIpId);
    var objArr = divObj.getElementsByTagName ("INPUT");
    if (!objArr.length) return false;
    var displayTdObj = document.getElementById (displayTdId);
    if (!displayTdObj) return;
    if (!objArr[0].disabled && objArr[0].value != "") {
        displayTdObj.innerHTML = objArr[0].value + '.' + objArr[1].value + '.' + objArr[2].value + '.' + objArr[3].value;
    }
}

function displaySummary () {
    setFieldVal ('txtPorName', 'tdPortalName', 'hdPortalName');
    setFieldVal ('txtPorTle', 'tdPortalTitle');
    setFieldVal ('txtBanTle', 'tdBannerTitle');
    setFieldVal ('txtBanMsg', 'tdBannerMsg');
    setFieldVal ('txtDomName', 'tdDomainName', 'hdDomainName');
    setFieldVal ('selAuthType', 'tdAuthType');
    setFieldVal ('txtPorName', 'tdSelectPortal', 'hdPortalName');
    setFieldVal ('txtAuthSvr1', 'tdAuthServer');
    setFieldVal ('txtDomName', 'tdGroupName', 'hdDomainName');
    setFieldVal ('txtDomName', 'tdGroupDomain', 'hdDomainName');
    setFieldVal ('txtUserName', 'tdUsername');
    setFieldVal ('txtDomName', 'tdUserGroup', 'hdDomainName');
    setFieldVal ('txtTimeOut', 'tdIdleTimeout');
    setFieldVal ('txtDnsSuffix', 'tdDnsSuffix');
    setFieldVal ('txtPort', 'tdPortNumber');
    setFieldVal ('txtFQDN', 'tdQualifiedDomain');
    setIpAddressVal ('tblPriDnsServer', 'tdPriDnsServer');
    setIpAddressVal ('tblSecDnsServer', 'tdSecDnsServer');
    setIpAddressVal ('tblSnmpStrIpAddr', 'tdClientBegin');
    setIpAddressVal ('tblSnmpEndIpAddr', 'tdClientEnd');
    setIpAddressVal ('tblIPAddr', 'tdLocalServer');
    setIpAddressVal ('tblSvrIPAddr', 'tdLocalIpAddress');
    var fullTunnelObj = document.getElementById ('chkEnbFullTnl');
    if (fullTunnelObj) {
    	setChkboxVal (fullTunnelObj, 'chkDisplayFullTunnel');
    }
    var vpnTunnelObj = document.getElementById ('chkVpnTunnel');
    if (vpnTunnelObj) {
    	setChkboxVal (vpnTunnelObj, 'chkDisplayVpnTunnel');
    }
    var portForwardingObj = document.getElementById ('chkPortForwarding');
    if (portForwardingObj) {
    	setChkboxVal (portForwardingObj, 'chkDisplayPortForwarding');
    }
    var activeCacheObj = document.getElementById ('chkActiveCache');
    if (activeCacheObj) {
    	setChkboxVal (activeCacheObj, 'chkDisplayActiveCache');
    }
    var httpMetaObj = document.getElementById ('chkHttpMeta');
    if (httpMetaObj) {
    	setChkboxVal (httpMetaObj, 'chkDisplayHttpMetaTags');
    }
    var bannerMsgObj = document.getElementById ('chkBannerMsg');
    if (bannerMsgObj) {
    	setChkboxVal (bannerMsgObj, 'chkDisplayBannerMsg');
    }
}

function enablePortalPageSections () {
	var vpnTunnelObj = document.getElementById ('chkVpnTunnel');
    var portForwardingObj = document.getElementById ('chkPortForwarding');
    if (!vpnTunnelObj || !portForwardingObj) return;
	if (!vpnTunnelObj.checked) {
		fieldStateChangeWr ('', 'tblClientAddress tblAddRoute', '', '');
	}
	else {
		fieldStateChangeWr ('', '', '', 'tblClientAddress');
		enableTunnelSection ();
	}
	if (!portForwardingObj.checked) {
		fieldStateChangeWr ('', 'tblConfiguredApp tblHostName', '', '');
	}
	else {
		fieldStateChangeWr ('', '', '', 'tblConfiguredApp tblHostName');
	}
}

function enableTunnelSection () {
	var tunnelObj = document.getElementById ('chkEnbFullTnl');
    if (tunnelObj.checked)
        fieldStateChangeWr ('', 'tblAddRoute', '', '');
    else
        fieldStateChangeWr ('', '', '', 'tblAddRoute');
}
